5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 . "${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 ${toggle_fast_unaligned} don't use unaligned accesses, even when
27 supported by hardware [auto]
28 ${toggle_codec_srcs} in/exclude codec library source code
29 ${toggle_debug_libs} in/exclude debug version of libraries
30 ${toggle_md5} support for output of checksum data
31 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
32 ${toggle_vp8} VP8 codec support
33 ${toggle_psnr} output of PSNR data, if supported (encoders)
34 ${toggle_mem_tracker} track memory usage
35 ${toggle_postproc} postprocessing
36 ${toggle_multithread} multithreaded encoding and decoding.
37 ${toggle_spatial_resampling} spatial sampling (scaling) support
38 ${toggle_realtime_only} enable this option while building for real-time encoding
39 ${toggle_runtime_cpu_detect} runtime cpu detection
40 ${toggle_shared} shared library support
43 Codecs can be selectively enabled or disabled individually, or by family:
46 --disable-<codec>-encoder
47 --disable-<codec>-decoder
49 Codecs available in this distribution:
51 #restore editor state '
57 for c in ${CODECS}; do
59 if [ "${family}" != "${last_family}" ]; then
60 [ -z "${str}" ] || echo "${str}"
61 str="$(printf ' %10s:' ${family})"
63 str="${str} $(printf '%10s' ${c#*_})"
71 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
74 # all_platforms is a list of all supported target platforms. Maintain
75 # alphabetically by architecture, generic-gnu last.
76 all_platforms="${all_platforms} armv5te-linux-rvct"
77 all_platforms="${all_platforms} armv5te-linux-gcc"
78 all_platforms="${all_platforms} armv5te-symbian-gcc"
79 all_platforms="${all_platforms} armv5te-wince-vs8"
80 all_platforms="${all_platforms} armv6-darwin-gcc"
81 all_platforms="${all_platforms} armv6-linux-rvct"
82 all_platforms="${all_platforms} armv6-linux-gcc"
83 all_platforms="${all_platforms} armv6-symbian-gcc"
84 all_platforms="${all_platforms} armv6-wince-vs8"
85 all_platforms="${all_platforms} iwmmxt-linux-rvct"
86 all_platforms="${all_platforms} iwmmxt-linux-gcc"
87 all_platforms="${all_platforms} iwmmxt-wince-vs8"
88 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
89 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
90 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
91 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
92 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
93 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
94 all_platforms="${all_platforms} mips32-linux-gcc"
95 all_platforms="${all_platforms} ppc32-darwin8-gcc"
96 all_platforms="${all_platforms} ppc32-darwin9-gcc"
97 all_platforms="${all_platforms} ppc64-darwin8-gcc"
98 all_platforms="${all_platforms} ppc64-darwin9-gcc"
99 all_platforms="${all_platforms} ppc64-linux-gcc"
100 all_platforms="${all_platforms} x86-darwin8-gcc"
101 all_platforms="${all_platforms} x86-darwin8-icc"
102 all_platforms="${all_platforms} x86-darwin9-gcc"
103 all_platforms="${all_platforms} x86-darwin9-icc"
104 all_platforms="${all_platforms} x86-linux-gcc"
105 all_platforms="${all_platforms} x86-linux-icc"
106 all_platforms="${all_platforms} x86-solaris-gcc"
107 all_platforms="${all_platforms} x86-win32-gcc"
108 all_platforms="${all_platforms} x86-win32-vs7"
109 all_platforms="${all_platforms} x86-win32-vs8"
110 all_platforms="${all_platforms} x86_64-darwin9-gcc"
111 all_platforms="${all_platforms} x86_64-linux-gcc"
112 all_platforms="${all_platforms} x86_64-solaris-gcc"
113 all_platforms="${all_platforms} x86_64-win64-vs8"
114 all_platforms="${all_platforms} universal-darwin8-gcc"
115 all_platforms="${all_platforms} universal-darwin9-gcc"
116 all_platforms="${all_platforms} generic-gnu"
118 # all_targets is a list of all targets that can be configured
119 # note that these should be in dependency order for now.
120 all_targets="libs examples docs"
122 # all targets available are enabled, by default.
123 for t in ${all_targets}; do
124 [ -f ${source_path}/${t}.mk ] && enable ${t}
127 # check installed doxygen version
128 doxy_version=$(doxygen --version 2>/dev/null)
129 doxy_major=${doxy_version%%.*}
130 if [ ${doxy_major:-0} -ge 1 ]; then
131 doxy_version=${doxy_version#*.}
132 doxy_minor=${doxy_version%%.*}
133 doxy_patch=${doxy_version##*.}
135 [ $doxy_major -gt 1 ] && enable doxygen
136 [ $doxy_minor -gt 5 ] && enable doxygen
137 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
140 # install everything except the sources, by default. sources will have
141 # to be enabled when doing dist builds, since that's no longer a common
143 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
148 enable fast_unaligned #allow unaligned accesses, if supported by hw
150 enable spatial_resampling
153 [ -d ${source_path}/../include ] && enable alt_tree_layout
155 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
158 if ! enabled alt_tree_layout; then
159 # development environment
160 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
162 # customer environment
163 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
164 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
166 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
169 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
170 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
288 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
289 *) process_common_cmdline $opt
295 post_process_cmdline() {
298 # If the codec family is disabled, disable all components of that family.
299 # If the codec family is enabled, enable all components of that family.
300 log_echo "Configuring selected codecs"
301 for c in ${CODECS}; do
302 disabled ${c%%_*} && disable ${c}
303 enabled ${c%%_*} && enable ${c}
306 # Enable all detected codecs, if they haven't been disabled
307 for c in ${CODECS}; do soft_enable $c; done
309 # Enable the codec family if any component of that family is enabled
310 for c in ${CODECS}; do
311 enabled $c && enable ${c%_*}
314 # Set the {en,de}coders variable if any algorithm in that class is enabled
315 for c in ${CODECS}; do
316 enabled ${c} && enable ${c##*_}s
324 enabled child || write_common_config_banner
325 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
327 # TODO: add host tools target (obj_int_extract, etc)
329 # For fat binaries, call configure recursively to configure for each
330 # binary architecture to be included.
331 if enabled universal; then
332 # Call configure (ourselves) for each subarchitecture
333 for arch in $fat_bin_archs; do
334 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
338 # The write_common_config (config.mk) logic is deferred until after the
339 # recursive calls to configure complete, becuase we want our universal
340 # targets to be executed last.
341 write_common_config_targets
342 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
344 # Calculate the default distribution name, based on the enabled features
347 for cf in $CODEC_FAMILIES; do
348 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
349 DIST_DIR="${DIST_DIR}-${cf}"
350 elif enabled ${cf}_encoder; then
351 DIST_DIR="${DIST_DIR}-${cf}cx"
352 elif enabled ${cf}_decoder; then
353 DIST_DIR="${DIST_DIR}-${cf}dx"
356 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
357 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
358 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
359 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
360 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
361 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
363 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
364 DIST_DIR="${DIST_DIR}-${tgt_cc}"
367 if [ -f "${source_path}/build/make/version.sh" ]; then
368 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
369 DIST_DIR="${DIST_DIR}-${ver}"
371 VERSION_PATCH=${ver##*.}
373 VERSION_MINOR=${ver##*.}
375 VERSION_MAJOR=${ver%.*}
377 enabled child || cat <<EOF >> config.mk
378 ifeq (\$(MAKECMDGOALS),dist)
379 DIST_DIR?=${DIST_DIR}
381 DIST_DIR?=\$(DESTDIR)${prefix}
383 LIBSUBDIR=${libdir##${prefix}/}
385 VERSION_MAJOR=${VERSION_MAJOR}
386 VERSION_MINOR=${VERSION_MINOR}
387 VERSION_PATCH=${VERSION_PATCH}
390 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
393 # Write makefiles for all enabled targets
395 for tgt in libs examples docs solution; do
396 local tgt_fn="$tgt-$toolchain.mk"
398 if enabled $tgt; then
399 echo "Creating makefiles for ${toolchain} ${tgt}"
400 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
408 if enabled shared; then
409 # Can only build shared libs on a subset of platforms. Doing this check
410 # here rather than at option parse time because the target auto-detect
411 # magic happens after the command line has been parsed.
412 enabled linux || die "--enable-shared only supported on ELF for now"
414 if [ -z "$CC" ]; then
415 echo "Bypassing toolchain for environment detection."
416 enable external_build
418 log fake_check_header "$@"
421 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
430 [ -f "${d##-I}/$header" ] && result=true && break
439 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
440 check_ld <<EOF || die "Toolchain is unable to link executables"
441 int main(void) {return 0;}
443 # check system headers
444 check_header stdint.h
445 check_header pthread.h
446 check_header sys/mman.h
448 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
451 process_toolchain() {
452 process_common_toolchain
454 # Handle universal binaries for this architecture
457 local darwin_ver=${tgt_os##darwin}
458 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
461 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
462 if [ $darwin_ver -gt 8 ]; then
463 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
469 # Enable some useful compiler flags
471 enabled werror && check_add_cflags -Werror
472 check_add_cflags -Wall
473 check_add_cflags -Wdeclaration-after-statement
474 check_add_cflags -Wdisabled-optimization
475 check_add_cflags -Wpointer-arith
476 check_add_cflags -Wtype-limits
477 check_add_cflags -Wcast-qual
478 enabled extra_warnings || check_add_cflags -Wno-unused
482 enabled werror && check_add_cflags -Werror
483 check_add_cflags -Wall
484 check_add_cflags -Wpointer-arith
486 # ICC has a number of floating point optimizations that we disable
487 # in favor of deterministic output WRT to other compilers
488 add_cflags -fp-model precise
491 # Enable extra, harmless warnings. These might provide additional insight
492 # to what the compiler is doing and why, but in general, but they shouldn't
493 # be treated as fatal, even if we're treating warnings as errors.
495 -Wdisabled-optimization
498 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
499 RVCT_EXTRA_WARNINGS="
502 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
503 if enabled extra_warnings; then
504 for w in ${EXTRA_WARNINGS}; do
505 check_add_cflags ${w}
506 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
510 # ccache only really works on gcc toolchains
511 enabled gcc || soft_disable ccache
512 if enabled mips; then
513 enable dequant_tokens
517 # Enable the postbuild target if building for visual studio.
521 vs_version=${tgt_cc##vs}
522 all_targets="${all_targets} solution"
524 FORCEINLINE=__forceinline
528 # Other toolchain specific defaults
529 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
534 ## END APPLICATION SPECIFIC CONFIGURATION
538 cat <<EOF > ${BUILD_PFX}vpx_config.c
539 static const char* const cfg = "$CONFIGURE_ARGS";
540 const char *vpx_codec_build_config(void) {return cfg;}